//+------------------------------------------------------------------+
//|                                           Buldozer_01_2+mod.mq4 |
//+------------------------------------------------------------------+
//          Mik 2806  2  MinPipStepBuy, MinPipStepSell. (2.08.2011 FastProfit)
//#property copyright "Copyright  2010, ir0407"
//#property link      "wlmaster@mail.ru"
#include <stderror.mqh>
#include <stdlib.mqh>

extern bool   EnableBuy      = True;
extern bool   EnableSell     = True;
extern double InitialLots    = 0.1;   //     
extern double LotsExponent   = 1.4;   //        . :   0.1, : 0.16, 0.26, 0.43 ...
extern int    OrdersMax      = 10;     // - 
//*****
extern int    MinPipStepBuy  = 5;     //      Buy,    Buy  
extern int    MinPipStepSell = 5;     //      Sell,    Sell  
//*****
extern bool   EnableDynLots  = False; //     
extern double DynLotsPercent = 10.0;  //        
//extern bool   LotsBalance    = False;
extern int    InitialTP      = 10;    //        

extern bool   DynamicTP = False;      // (True)/(False)    
extern int    DynamicTPMode = 0;       // 0 -      
                                    // 1 -      
                                    // 2 -     FastProfit   MT5.com
extern int    MinTP = 5;              //   
extern double TPExponent = 0.9;     //    (   DynamicTPMode = 0)
extern int    TPArithmeticStep = -2;   //     (   DynamicTPMode = 1)

extern bool   UseStaticPipstep = False;
extern int    StaticPipstep  = 20;
extern bool   UseCalculatedPipstep = False;
extern int    AnalizeDepth   = 35;
extern int    AnalizeDel     = 3;

extern bool   UsePipstepExponent = False;
extern double PipStepExponent = 1.3;
extern string Quant = "/.   . TRUE-";
extern bool   QuantumStep = true;    //     
extern string StartStepExpSrting = "       PipStepExponent";
extern int    StartStepExp = 5;       //     

extern bool   EnableRsi      = False;
extern double RsiMinimum     = 30.0;    //   RSI
extern double RsiMaximum     = 70.0;    //   RSI
extern int    MN_Buy         = 12345;      //   (      )
extern int    MN_Sell        = 54321;      //   (      )
extern bool   Debug          = True;
extern bool   Info           = True;
//********************************************************************

string ExpertName = "Buldozer";
datetime NewBarOpenTime;
double LastTickTime, DynamicLots;
int LotsDecimal;
bool InitFail = False;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  InitFail = False;
  Comment("");
  if(!IsExpertEnabled())
  {
    Comment("  \"\"");
    InitFail = True; 
    return(0);
  }
  if(!IsTradeAllowed()) 
  {
    Comment("    \n"+
            "  ");
    InitFail = True; 
    return(0);
  }
  if(!IsLibrariesAllowed())
  {
    Comment("    \n"+
            "    ");
    InitFail = True;
    return(0);
  }
  NewBarOpenTime = Time[0];
  double lot = MarketInfo(Symbol(), MODE_MINLOT);
  if(lot = 0.01) LotsDecimal = 2;
  if(lot = 0.1) LotsDecimal = 2;
  
  return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  Comment("");
  return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  int TotalOrders, BuyOrders, SellOrders, PipStep, Signal, Ticket, NewTP, Error = 0;
  double LastBuyPrice, LastSellPrice, NewTPPrice, NewLots, SellLots, BuyLots, StartLots;

  /*****************************************************************************/
  /*   ,                        */ 
  /*****************************************************************************/

  
  /*****************************************************************************/
  if(NewBarOpenTime == Time[0]) return(0);   //   

  /*****************************************************************************/
  /*    ,        */ 
  /*****************************************************************************/
  NewBarOpenTime = Time[0];
  if(InitFail)
  { 
    if(Debug) Print("  .  .");
    return(0);
  }
  LastTickTime = MarketInfo(Symbol(),MODE_TIME);
  TotalOrders = CountOfOrders(); 
  Signal      = SignalCheck();

  StartLots = InitialLots;
  if(EnableDynLots)
  {
    DynamicLots = NormalizeDouble(AccountBalance() / 10000 * DynLotsPercent / 10, LotsDecimal);
    if(DynamicLots < MarketInfo(Symbol(), MODE_MINLOT))
    {
      Comment("\n!  .\n" +
              "     .\n" +
              "       .");
      InitFail = True;
      return(0);
    }
    StartLots = DynamicLots;
    if(Debug) Print("DynamicLots = ", DynamicLots);
  }
    
  /*****************************************************************************/
  /*   ,              */ 
  /*****************************************************************************/
  if(TotalOrders == 0)
  {
    //if(EnableDynLots)
    //  NewLots = DynamicLots;
    //else
    //  NewLots = InitialLots;
    switch(Signal)
    {
      case OP_BUY:
        if(EnableBuy)
        {
         if(Debug) Print("  BUY");
          if(EnableRsi)
          {
            if (iRSI(NULL, 0, 14, PRICE_CLOSE, 1) < RsiMaximum)
            {
              if(Debug) Print(" RSI ");
              Ticket = SendMarketOrder(OP_BUY, StartLots, InitialTP, 0, MN_Buy, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
            }
          }
          else
            Ticket = SendMarketOrder(OP_BUY, StartLots, InitialTP, 0, MN_Buy, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        }
        break;
      case OP_SELL:
        if(EnableSell)
        {
          if(Debug) Print("  SELL");
          if(EnableRsi)
          {
            if (iRSI(NULL, 0, 14, PRICE_CLOSE, 1) > RsiMinimum )
            {
              if(Debug) Print(" RSI ");
              Ticket = SendMarketOrder(OP_SELL, StartLots, InitialTP, 0, MN_Sell, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
            }
          }
          else
            Ticket = SendMarketOrder(OP_SELL, StartLots, InitialTP, 0, MN_Sell, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        }
        break;
      default:
        if(Debug) Print("   ,   .");
        break;
    }
    return(0);
  }
  /****************************************************************************************/
      //***
    if (Info){
    Comment("" 
         + "\n" 
         + "Buldozer_01.2+mod" 
         + "\n" 
         + "________________________________"  
         + "\n"
         + " :  " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)
         + "\n"        
         + "________________________________"  
         + "\n" 
         + "MN_Buy  = " + MN_Buy
         + "   "
         + "MN_Sell = " + MN_Sell         
         + "\n"
         + "  Buy  = " + DoubleToStr(NormalizeDouble(StartLots * MathPow(LotsExponent, CountOfBuy()), LotsDecimal),2)
         + "\n" 
         + "  Sell  = " + DoubleToStr(NormalizeDouble(StartLots * MathPow(LotsExponent, CountOfSell()), LotsDecimal),2)
         + "\n" 
         + " MinPipStepBuy  =      " + MinPipStepBuy
         + "\n" 
         + " MinPipStepSell =      " + MinPipStepSell
         + "\n"
         + "_______________________________"
         + "\n"
         + "  Buy :" + CountOfBuy()
         + "\n"
         + "  Sell :" + CountOfSell()
         + "\n"
         + "_______________________________"
         + "\n"           
         + ":                       " + DoubleToStr(AccountBalance(), 2)          
         + "\n" 
         + " :   " + DoubleToStr(AccountEquity(), 2)
         + "\n"      
         + "_______________________________");
         }
      //***

  /****************************************************************************************/  
  /*   ,            */ 
  /****************************************************************************************/
  if(TotalOrders > 0)
  {
    BuyOrders   = CountOfBuy();
    SellOrders  = CountOfSell();
    
    PipStep = InitialTP;
    if(UseStaticPipstep)
      PipStep = StaticPipstep;
    if(UseCalculatedPipstep)
      PipStep = CalculatePipStep();
        
    if(EnableBuy && (Signal == OP_BUY))
    {
      if(Debug) Print("  BUY");
      if(BuyOrders > 0 && BuyOrders < OrdersMax)
      {
        if(UsePipstepExponent)
          PipStep = NormalizeDouble(PipStep*MathPow(PipStepExp(BuyOrders),TradeStepExp(BuyOrders)),0);
        LastBuyPrice = FindLastBuyPrice();
        if((Ask < LastBuyPrice - (PipStep * Point)) && (Ask < LastBuyPrice - (MinPipStepBuy * Point)))
        {
          NewLots = NormalizeDouble(StartLots * MathPow(LotsExponent, BuyOrders), LotsDecimal);
          /*if(LotsBalance)
          {
            if(Debug) Print("   - ", NewLots);
            if(SellOrders > 0)
            {
              SellLots = GetSellLots();
              BuyLots = GetBuyLots();
              if((BuyLots + NewLots) < SellLots)
                NewLots = SellLots - BuyLots;
            }
            if(Debug) Print("   - ", NewLots);
          }*/
          Ticket = SendMarketOrder(OP_BUY, NewLots, 0, 0, MN_Buy, ExpertName + "-B" + (BuyOrders + 1) + "-" + DoubleToStr((LastBuyPrice - Ask) / Point, 0), Error);
          if(!(Ticket < 0))
          {
            NewTP = InitialTP;
            if(DynamicTP)
            {
              NewTP = CalculateTP(BuyOrders);
              if(NewTP < MinTP)
                NewTP = MinTP;
            }
            NewTPPrice = NormalizeDouble(CalculateAveragePriceBuy() + (NewTP * Point), Digits);
            //NewTPPrice = CalculateTPPrice( NewLots, BuyOrders, OP_BUY, MN_Buy);
            if(Debug) Print("  BUY-  ");
            for (int i1 = 0; i1 < OrdersTotal(); i1++) 
              if(OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
                if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
                  if(OrderType()== OP_BUY) 
                    ModifyOrder(NewTPPrice);
            
          }
          else
          {
            if(Debug) Print("  BUY-"); 
            return(0);
          }
        }
        else
          if(Debug) Print("    BUY-.   .");
      }
      if(BuyOrders == 0)
      {
        //if(EnableDynLots)
        //  NewLots = DynamicLots;
        //else
        //  NewLots = InitialLots;
      /*if(LotsBalance)
        {
          if(Debug) Print("   - ", NewLots);
          if(SellOrders > 0)
          {
            SellLots = GetSellLots();
            if(SellLots > NewLots)
              NewLots = SellLots;
          }
          if(Debug) Print("   - ", NewLots);
        }*/
        if(EnableRsi)
        {
          if (iRSI(NULL, 0, 14, PRICE_CLOSE, 1) < RsiMaximum)
          {
            if(Debug) Print(" RSI ");
            Ticket = SendMarketOrder(OP_BUY, StartLots, InitialTP, 0, MN_Buy, ExpertName + "-B" + (BuyOrders + 1) + "-" + 0, Error);
          }
        }
        else
          Ticket = SendMarketOrder(OP_BUY, StartLots, InitialTP, 0, MN_Buy, ExpertName + "-B" + (BuyOrders + 1) + "-" + 0, Error);
      }
      return(0);
    }
    //**************************************************
    if(EnableSell && (Signal == OP_SELL))
    {
      if(Debug) Print("  SELL");
      if(SellOrders > 0 && SellOrders < OrdersMax)
      {
        if(UsePipstepExponent)
          PipStep = NormalizeDouble(PipStep*MathPow(PipStepExp(SellOrders),TradeStepExp(SellOrders)),0);
        LastSellPrice = FindLastSellPrice();
        if((Bid > LastSellPrice + (PipStep * Point)) && (Bid > LastSellPrice + (MinPipStepSell * Point)))
        {
          NewLots = NormalizeDouble(StartLots * MathPow(LotsExponent, SellOrders), LotsDecimal);
          /*if(LotsBalance)
          {
            if(Debug) Print("   - ", NewLots);
            if(BuyOrders > 0)
            {
              SellLots = GetSellLots();
              BuyLots = GetBuyLots();
              if((SellLots + NewLots) < BuyLots)
                NewLots = BuyLots - SellLots;
            }
            if(Debug) Print("   - ", NewLots);
          }*/
          Ticket = SendMarketOrder(OP_SELL, NewLots, 0, 0, MN_Sell, ExpertName + "-S" + (SellOrders + 1) + "-" + DoubleToStr((Bid - LastSellPrice) / Point, 0), Error);
          if(!(Ticket < 0))
          {
            NewTP = InitialTP;
            if(DynamicTP)
            {
              NewTP = CalculateTP(SellOrders);
              if(NewTP < MinTP)
                NewTP = MinTP;
            }
            NewTPPrice = NormalizeDouble(CalculateAveragePriceSell() - (NewTP * Point), Digits);
            //NewTPPrice = CalculateTPPrice( NewLots, SellOrders, OP_SELL, MN_Sell);
            if(Debug) Print("  SELL-  ");
            for (int i2 = 0; i2 < OrdersTotal(); i2++) 
              if(OrderSelect(i2, SELECT_BY_POS, MODE_TRADES))
                if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
                  if(OrderType()== OP_SELL) 
                    ModifyOrder(NewTPPrice);
            
          }
          else
          {
            if(Debug) Print("  SELL-"); 
            return(0);
          }
        }
        else
          if(Debug) Print("    SELL-.   .");
      }
      if(SellOrders == 0)
      {
        //if(EnableDynLots)
        //  NewLots = DynamicLots;
        //else
        //  NewLots = InitialLots;
      /*if(LotsBalance)
        {
          if(Debug) Print("   - ", NewLots);
          if(BuyOrders > 0)
          {
            BuyLots = GetBuyLots();
            if(BuyLots > NewLots)
              NewLots = BuyLots;
          }
          if(Debug) Print("   - ", NewLots);
        }*/
        if(EnableRsi)
        {
          if (iRSI(NULL, 0, 14, PRICE_CLOSE, 1) > RsiMinimum )
          {
            if(Debug) Print(" RSI ");
            Ticket = SendMarketOrder(OP_SELL, StartLots, InitialTP, 0, MN_Sell, ExpertName + "-S" + (SellOrders + 1) + "-" + 0, Error);
          }
        }
        else
          Ticket = SendMarketOrder(OP_SELL, StartLots, InitialTP, 0, MN_Sell, ExpertName + "-S" + (SellOrders + 1) + "-" + 0, Error);
      }
    }
  }
  return(0);
}

//+------------------------------------------------------------------+
int CalculatePipStep()
{
  double hival = High[iHighest(NULL, 0, MODE_HIGH, AnalizeDepth, 1)];    
  double loval = Low[iLowest(NULL, 0, MODE_LOW, AnalizeDepth, 1)];       
  return(NormalizeDouble((hival - loval) / AnalizeDel / Point, 0));      
}

//+------------------------------------------------------------------+
int CountOfOrders()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && ((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell))) 
        if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfBuy()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Buy)) 
        if (OrderType() == OP_BUY) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int CountOfSell()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Sell)) 
        if (OrderType() == OP_SELL) 
          count++;
  return(count);
}

//+------------------------------------------------------------------+
int SignalCheck()
{
  double Bar1Close = NormalizeDouble(iClose(Symbol(), 0, 1), Digits);
  double Bar2Close = NormalizeDouble(iClose(Symbol(), 0, 2), Digits);
  if (MathAbs(NormalizeDouble((Bar1Close - Bar2Close) / Point, 0)) < 3) 
    return(-1);
  if (Bar1Close > Bar2Close)
    if(NormalizeDouble((Bar1Close - Bar2Close) / Point, 0) >= 3) 
      return(OP_BUY);
  if (Bar1Close < Bar2Close) 
    if(NormalizeDouble((Bar2Close - Bar1Close) / Point, 0) >= 3) 
      return(OP_SELL);
  return(-1);
}

//+------------------------------------------------------------------+
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  if(Debug) Print(" SendMarketOrder");
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Error = ERR_TRADE_DISABLED;
      Print("  !  \"\" .");
      return(-1);
    }
    if(Debug) Print("  ,  \"\" .");
    if(!IsConnected())
    {
      Error = ERR_NO_CONNECTION;
      Print("   !");
      return(-1);
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    if(Delay || (LastTickTime != MarketInfo(Symbol(),MODE_TIME))) 
    {
      if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(),MODE_TIME);
      Delay = False;
    }
    else
    {
      if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        if(Debug) Print("    .");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
        if (Err == 4   || /* SERVER_BUSY */
            Err == 129 || /* INVALID_PRICE */ 
            Err == 135 || /* PRICE_CHANGED */ 
            Err == 137 || /* BROKER_BUSY */ 
            Err == 138 || /* REQUOTE */ 
            Err == 146 || /* TRADE_CONTEXT_BUSY */
            Err == 136 )  /* OFF_QUOTES */
        {
          if(Debug) Print("(OrderSend - ", Err, "): ", ErrorDescription(Err));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      if(Debug) Print("  !     .");
      //Print(" 3 ...");
      //Sleep(3000);
      //Delay = True;
      //continue;
      break;
    }
  }
  if(Ticket > 0)
    if(Debug) Print("  .  = ",Ticket);
  else
    if(Debug) Print("!   . (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}

//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}

//+------------------------------------------------------------------+
double FindLastBuyPrice() 
{
  double LastPrice = 0;

  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy) 
          if(OrderType() == OP_BUY) 
          {
            if(LastPrice == 0)
            {
              LastPrice = OrderOpenPrice();
              continue;
            }
            if(OrderOpenPrice() < LastPrice)
            {
              LastPrice = OrderOpenPrice();
            }
          }
  return (NormalizeDouble(LastPrice, Digits));
}

//+------------------------------------------------------------------+
double FindLastSellPrice() 
{
  double LastPrice = 0;

  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN_Sell) 
          if(OrderType() == OP_SELL) 
          {
            if(LastPrice == 0)
            {
              LastPrice = OrderOpenPrice();
              continue;
            }
            if(OrderOpenPrice() > LastPrice)
            {
              LastPrice = OrderOpenPrice();
            }
          }
  return(NormalizeDouble(LastPrice, Digits));
}

//+------------------------------------------------------------------+
double CalculateAveragePriceBuy()
{
  double AveragePrice = 0;
  double Count = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
        if (OrderType() == OP_BUY) 
        {
           AveragePrice += OrderOpenPrice() * OrderLots();
           Count += OrderLots();
        }
  if(AveragePrice > 0 && Count > 0)
    return( NormalizeDouble(AveragePrice / Count, Digits));
  else
    return(0);
}

//+------------------------------------------------------------------+
double CalculateAveragePriceSell()
{
  double AveragePrice = 0;
  double Count = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
        if (OrderType() == OP_SELL) 
        {
           AveragePrice += OrderOpenPrice() * OrderLots();
           Count += OrderLots();
        }
  if(AveragePrice > 0 && Count > 0)
    return( NormalizeDouble(AveragePrice / Count, Digits));
  else
    return(0);
}

//+------------------------------------------------------------------+
bool ModifyOrder( double takeprofit)
{
  while(!IsStopped())
  {
    if(Debug) Print(" ModifyOrder");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      Sleep(3000);
      continue;
    }
    if(Debug) Print("  ");
    if(!IsTradeAllowed())
    {
      if(Debug) Print("      !");
      Sleep(3000);
      continue;
    }
    if(Debug) Print(" ,   #",OrderTicket());
    if(!OrderModify(OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble(takeprofit,Digits), 0, Yellow))
    {
      if(Debug) Print("   ");
      int Err = GetLastError();
      if(Debug) Print("(",Err,"): ",ErrorDescription(Err));
      break;
      //Sleep(1000);
      //continue;
    }
    else
    {
      if(Debug) Print("   ");
      break;
    }
  }
  return(True);
}

//--------------------    StartStepExp -------------------------------

double PipStepExp(int Step)
{
   double QStepEx =  0;
   if(QuantumStep == true && Step >= StartStepExp)
   QStepEx = PipStepExponent;
   else
   QStepEx = 1;
return (QStepEx);
}
//====================   ============================
int TradeStepExp(int Trades)
{
   double TradeStep = 0;
   if(QuantumStep == true && Trades >= StartStepExp)
   TradeStep = Trades - StartStepExp + 1;
   else
   TradeStep = Trades;
return (TradeStep);
}

//
int CalculateTP(int Count)
{
  int Result = 0;
  if(DynamicTPMode == 0)
  { // 
    Result = NormalizeDouble(InitialTP * MathPow(TPExponent, Count), 0);  
  }
  if(DynamicTPMode == 1)
  { //  
    Result = NormalizeDouble(InitialTP + Count * TPArithmeticStep, 0);  
  }
  if(DynamicTPMode == 2)
  { //   FastProfit   MT5.com
    Result = NormalizeDouble(InitialTP - MathRound((InitialTP - MinTP) * Count / OrdersMax),0);
  }
  return(Result);
}

