//+------------------------------------------------------------------+
//|                                                          CMI.mq4 |
//|                                            Copyright  2011, NiX |
//|                                http://www.the-forex-strategy.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, NiX"
#property link      "http://www.the-forex-strategy.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_color4 DodgerBlue
#property indicator_level1 60
#property indicator_level2 50
#property indicator_level3 40
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_maximum 100
#property indicator_minimum 0

double arr[];
double pos[];
double neg[];
double ma[];

extern int period = 60;
extern int MAperiod = 10;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    IndicatorBuffers(4);
    SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(0,arr);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexBuffer(1,pos);
    SetIndexStyle(2,DRAW_LINE);
    SetIndexBuffer(2,neg);
    SetIndexStyle(3,DRAW_LINE);
    SetIndexBuffer(3,ma);
    SetIndexLabel(0,"CMI");
    SetIndexLabel(1,"C2C postive");
    SetIndexLabel(2,"C2C negative");
    SetIndexLabel(3,"Signal MA");
    SetIndexEmptyValue(0,EMPTY_VALUE);
    SetIndexEmptyValue(1,EMPTY_VALUE);
    SetIndexEmptyValue(2,EMPTY_VALUE);
    SetIndexEmptyValue(3,EMPTY_VALUE);
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

bool downloadhistory=false;
double cmi;
double col;

int start()
{

   int limit, i, counted_bars=IndicatorCounted();
   
   if(counted_bars<0) 
      return(-1);
   if(counted_bars==0 && downloadhistory) // history was downloaded
   {
      Print("More history downloaded - recalculating "+Symbol()+","+Period());
      firstRun();
   }
   if(counted_bars==0) 
   {
      limit=Bars-counted_bars-2;   
      downloadhistory=true;
   }
   if(counted_bars>0) 
   {
      limit=Bars-counted_bars-2;   
      if(limit < 0)
         limit = 0;
   }

   for(int shift=limit; shift>=0; shift--)
   {
      calculateValue(shift, period);
      
      arr[shift] = cmi;
      if(col == 1)
      {
         pos[shift] = cmi;
         neg[shift] = EMPTY_VALUE;
      }
      else if(col == -1)
      {
         neg[shift] = cmi;
         pos[shift] = EMPTY_VALUE;
      }
      else
      {
         pos[shift] = EMPTY_VALUE;
         neg[shift] = EMPTY_VALUE;      
      }

   }
          
   for(shift=limit; shift>=0; shift--)
   {
      ma[shift] = iMAOnArray(arr,0,MAperiod,0,MODE_SMA,shift);
   }
   return(0);
  }
//+------------------------------------------------------------------+

void firstRun()
{
   ArrayInitialize(arr,EMPTY_VALUE);
   ArrayInitialize(pos,EMPTY_VALUE);
   ArrayInitialize(neg,EMPTY_VALUE);
   ArrayInitialize(ma,EMPTY_VALUE);
}

void calculateValue(int ix, int n)
{
  double cc = iClose(Symbol(),Period(),ix)-iClose(Symbol(),Period(),ix+n);
  double h = iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,n,ix));
  double l = iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,n,ix));
 
  if(cc > 0)
   col = 1;
  else if(cc < 0)
   col = -1;
  else 
   col = 0;
  
  if((h-l) == 0)
   cmi = 0;
  else
   cmi = ((MathAbs(cc)) / (h-l))*100;
}