//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
// Indicator properties
#property strict
#property indicator_separate_window
#property indicator_buffers 9
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_color1    Lime
#property indicator_width1    14
#property indicator_color2    Gray
#property indicator_width2    14
#property indicator_color3    Red
#property indicator_width3    14

#define INDICATOR_NAME "EsikeM15Bomb"

// Indicator parameters
extern int                RSI_Period=13;
extern ENUM_APPLIED_PRICE RSI_Price=PRICE_CLOSE;
extern int                Volatility_Band=34;
extern int                RSISignal_Period=2;
extern ENUM_MA_METHOD     RSISignal_Mode=MODE_SMA;
extern int                TradeSignal_Period=7;
extern ENUM_MA_METHOD     TradeSignal_Mode=MODE_SMA;

// Global module varables
double Buy[];
double Wait[];
double Sell[];
double gdaRSI[];
double gdaRSISig[];
double gdaTradeSig[];
double gdaMktBase[];
double gdaVolaTop[];
double gdaVolaBtm[];
//-----------------------------------------------------------------------------
// function: init()
// Description: Custom indicator initialization function.
//-----------------------------------------------------------------------------
int init()
  {
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Buy);
   SetIndexLabel(0,"Buy");
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Wait);
   SetIndexLabel(1,"Wait");
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Sell);
   SetIndexLabel(2,"Sell");
   SetIndexBuffer(3,gdaVolaTop);
   SetIndexLabel(3,"Volatility Top");
   SetIndexBuffer(4,gdaVolaBtm);
   SetIndexLabel(4,"Volatility Bottom");
   SetIndexBuffer(5,gdaMktBase);
   SetIndexLabel(5,"Market Base");
   SetIndexBuffer(6,gdaTradeSig);
   SetIndexLabel(6,"Trade Signal");
   SetIndexBuffer(7,gdaRSISig);
   SetIndexLabel(7,"RSI Signal");
   SetIndexBuffer(8,gdaRSI);
   SetIndexLabel(8,NULL);
   IndicatorDigits(1);
   IndicatorShortName(INDICATOR_NAME);
   return(0);
  }
//-----------------------------------------------------------------------------
// function: deinit()
// Description: Custom indicator deinitialization function.
//-----------------------------------------------------------------------------
int deinit()
  {
   return (0);
  }
///-----------------------------------------------------------------------------
// function: start()
// Description: Custom indicator iteration function.
//-----------------------------------------------------------------------------
int start()
  {
   int iNewBars,iCountedBars,i;

// Get unprocessed bars
   iCountedBars=IndicatorCounted();
   if(iCountedBars < 0) return (-1);
   if(iCountedBars>0) iCountedBars--;
   iNewBars=MathMin(Bars-iCountedBars,Bars-1);

// Calc TDI data
   for(i=iNewBars-1; i>=0; i--)
     {
      gdaRSI[i]=iRSI(NULL,0,RSI_Period,RSI_Price,i);
     }
   for(i=iNewBars-1; i>=0; i--)
     {
      gdaRSISig[i]=iMAOnArray(gdaRSI,0,RSISignal_Period,0,RSISignal_Mode,i);
      gdaTradeSig[i]=iMAOnArray(gdaRSI,0,TradeSignal_Period,0,TradeSignal_Mode,i);
      gdaMktBase[i]=iMAOnArray(gdaRSI,0,Volatility_Band,0,MODE_SMA,i);
      gdaVolaTop[i]=gdaMktBase[i]+1.6185 * iStdDevOnArray(gdaRSI,0,Volatility_Band,0,MODE_SMA,i);
      gdaVolaBtm[i]=gdaMktBase[i]-1.6185 * iStdDevOnArray(gdaRSI,0,Volatility_Band,0,MODE_SMA,i);
     }

   int s,l,c=IndicatorCounted();

   if( c < 0 ) return(-1);
   if(c==0)
      l=Bars;
   if(c>0)
      l=Bars-c;
   l--;

   for(s=l; s>=0; s--)
     {
      if(gdaRSISig[s]>gdaTradeSig[s] && gdaRSISig[s]>50 && gdaRSISig[s]<90 && gdaTradeSig[s]>50 && gdaTradeSig[s]<90 && gdaMktBase[s]>50 && gdaMktBase[s]<80)
        {
         Buy[s]=1;
         Sell[s]=0;
         Wait[s]=0;
        }
      if(gdaRSISig[s]<gdaTradeSig[s] && gdaRSISig[s]<50 && gdaRSISig[s]>10 && gdaTradeSig[s]<50 && gdaTradeSig[s]>10 && gdaMktBase[s]<50 && gdaMktBase[s]>20)
        {
         Buy[s]=0;
         Sell[s]=1;
         Wait[s]=0;
        }
      if(Buy[s]+Sell[s]>1)
        {
         Buy[s]=0;
         Sell[s]=0;
         Wait[s]=1;
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
