//+------------------------------------------------------------------+
//|                                       Kolier_MA_Crossover_EA.mq4 |
//|                                       Copyright 2010, KoliEr Li. |
//|                                                 http://kolier.li |
//+------------------------------------------------------------------+
/*
 * I here get paid to program for you. Just $15 for all scripts.
 *
 * I am a bachelor major in Financial-Mathematics.
 * I am good at programming in MQL for Meta Trader 4 platform. Senior Level. Have done hundreds of scripts.
 * No matter what it is, create or modify any indicators, expert advisors and scripts.
 * I will ask these jobs which are not too large, price from $15, surely refundable if you are not appreciate mine.
 * All products will deliver in 3 days.
 * Also, I am providing EA, Indicator and Trade System Improvement Consultant services, contact me for the detail.
 * If you need to have it done, don't hesitate to contact me at: kolier.li@gmail.com
 */
 
#property copyright "Copyright 2010, KoliEr Li."
#property link      "http://kolier.li"
// Client: 
// Tags: 
// Revision: 2

/* Change Logs */
/*
2. 1.0.2(2011-07-01) Fix the conflict between CloseOpposite and AllowHedge.
*/

//+------------------------------------------------------------------+
//| Universal Constants                                              |
//+------------------------------------------------------------------+
#define TRADEPEND  -1
#define TRADEALL   0
#define TRADETRADE 1
#define TRADEBUY   1
#define TRADESELL  -1

//+------------------------------------------------------------------+
//| User input variables                                             |
//+------------------------------------------------------------------+
extern string     AdvisorName = "Kolier_MA_Crossover_EA";          // For Logging
extern string  AdvisorVersion = "1.0.2";            // The version number of this script
extern string     ProjectPage = "http://kolier.li/project/kolier-ma-crossover-ea";            // The project landing page
extern string  Entry_Exit = "Entry & Exit Settings";
extern bool    TradeAtBarOpen = false; // false means trade immediately when ma cross, true means trade only confirmed cross after the bar close
extern int     AllowBuyAmount = 1; // The number of amount allow opening buy orders
extern int    AllowSellAmount = 1; // he number of amount allow opening buy orders
extern bool        AllowHedge = true; // Whether allow open buy and sell together
extern bool     CloseOpposite = true; // Whether close opposite orders when trade signal shows
// iMA
extern string       MAFast_iMA = "http://kolier.li/example/mt4-ima-system-moving-average";
extern int       MAFast_Period = 5;           // MA Period
extern int        MAFast_Shift = 0;           // MA Shift
extern int       MAFast_Method = 0;           // 0=sma, 1=ema, 2=smma, 3=lwma
extern int        MAFast_Price = 0;           // 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weighted
// iMA
extern string       MASlow_iMA = "http://kolier.li/example/mt4-ima-system-moving-average";
extern int       MASlow_Period = 10;           // MA Period
extern int        MASlow_Shift = 0;           // MA Shift
extern int       MASlow_Method = 0;           // 0=sma, 1=ema, 2=smma, 3=lwma
extern int        MASlow_Price = 0;           // 0=close, 1=open, 2=high, 3=low, 4=median, 5=typical, 6=weighted
// Trade Time Filter - @see http://kolier.li/example/script-function-trade-time-filter
extern string Trade_Time_Filter = "http://kolier.li/example/script-function-trade-time-filter";
extern bool   TradeTimeFilter = false;          // Whether to use trade time filter
extern string      TradeBegin = "07:00";       // Don't trade before this time
extern string        TradeEnd = "19:00";       // Don't trade after this time
extern bool     EndInTomorrow = false;         // Whether TradeEnd is the next day, like you want to trade the period: 18:00~06:00, the 06:00 is the next am
// Order Operation - Open: @see http://kolier.li/example/script-function-order-operation-open
extern string Order_Operation_Open = "http://kolier.li/example/script-function-order-operation-open";
extern bool         ECNBroker = false;         // Whether using ECN broker
extern int              Magic = 222222;        // For identify trades belong to this EA, set to unique on different chart when using at the same time
extern int           Slippage = 3;             // Allow slippage
extern double            Lots = 0.1;           // Trade lots
extern bool       StealthMode = false;         // Whether TakeProfit and StopLoss in Stealth Mode, hiding from the broker
extern double      TakeProfit = 0;             // In Pips. Take Profit, Change to 0 if you don't want to use.
extern double        StopLoss = 0;             // In Pips. Stop Loss, Change to 0 if you don't want to use.
// Order Operation - Break Even: @see http://kolier.li/example/script-function-order-operation-breakeven
extern string Order_Operation_BreakEven = "http://kolier.li/example/script-function-order-operation-breakeven";
extern bool      UseBreakEven = false;          // Whether using BreakEven
extern bool    BE_StealthMode = false;         // Whether using BreakEven in Stealth Mode
extern double   BreakEvenPips = 20;            // In Pips. BreakEven Pips.
extern bool BreakEvenWithProfit = false;       // Different from normal BreakEven, you can make a little in BreakEven, like 1~2 pips
extern double BreakEvenProfit = 3;             // In Pips. BreakEven Pips take profit.
// Order Operation - Trailing Stop: @see http://kolier.li/example/script-function-order-operation-trailing-stop
extern string Order_Operation_Trailing_Stop = "http://kolier.li/example/script-function-order-operation-trailing-stop";
extern bool      UseTrailStop = false;          // Whether using TrailStop
extern bool    TrailAfterEven = true;          // Whether using TrailStop after the range between current price and the OrderOpenPrice >= TrailStopPips
extern bool    TS_StealthMode = false;         // Whether using TrailStop in Stealth Mode
extern double   TrailStopPips = 20;            // In Pips. TrailStop Pips
extern bool  TS_MovingInChunk = false;         // Whether wait for price move a range to set new SL
extern double        TS_Chunk = 10;            // In Pips. Moving pips as chunk


//+------------------------------------------------------------------+
//| Universal variables                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   // Clear the un-used Global Variables
   GlobalVariablesDeleteAll(AdvisorName);

   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   // BreakEven && TrailStop && StealthMode
   if(scanTrades(TRADETRADE)>0) {
      if(UseBreakEven) breakEven();
      if(UseTrailStop) trailStop();
      if(StealthMode) stealthMode();
   }
   
   // Trade Time Filter
   if(!TradeTimeFilter || (TradeTimeFilter && tradeTime())) {
      double ma_fast[3], ma_slow[3];
      int which_bar;
      for(int i=0; i<3; i++) {
         ma_fast[i] = iMA(Symbol(), 0, MAFast_Period, MAFast_Shift, MAFast_Method, MAFast_Price, i);
         ma_slow[i] = iMA(Symbol(), 0, MASlow_Period, MASlow_Shift, MASlow_Method, MASlow_Price, i);
      }

      if(TradeAtBarOpen) {
         which_bar = 1;
      }
      else {
         which_bar = 0;
      }
      
      if(ma_fast[which_bar]>ma_slow[which_bar] && ma_fast[which_bar+1]<ma_slow[which_bar+1]
         && !tradedInBarOP(OP_BUY) && scanTrades(TRADETRADE,TRADEBUY)<AllowBuyAmount
         && (AllowHedge || (!AllowHedge && scanTrades(TRADETRADE,TRADESELL)==0))) {
         tradeBuy();
         
      }
      if(ma_fast[which_bar]<ma_slow[which_bar] && ma_fast[which_bar+1]>ma_slow[which_bar+1]
         && !tradedInBarOP(OP_SELL) && scanTrades(TRADETRADE,TRADESELL)<AllowSellAmount
         && (AllowHedge || (!AllowHedge && scanTrades(TRADETRADE,TRADEBUY)==0))) {
         tradeSell();
      }
   }
   
   if(CloseOpposite) {
      if(ma_fast[which_bar]>ma_slow[which_bar] && ma_fast[which_bar+1]<ma_slow[which_bar+1]) {
         while(scanTrades(TRADETRADE,TRADESELL)>0) {
            closeTradesSell();
         }
      }
      if(ma_fast[which_bar]<ma_slow[which_bar] && ma_fast[which_bar+1]>ma_slow[which_bar+1]) {
         while(scanTrades(TRADETRADE,TRADEBUY)>0) {
            closeTradesBuy();
         }
      }
   }
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Trade Time Filter @http://kolier.li                              |
//|   @see http://kolier.li/example/script-function-trade-time-filter|
//+------------------------------------------------------------------+
bool tradeTime()
  {
   if(TradeTimeFilter) {
      datetime time_now, time_begin, time_end, time_end_today;
      time_now = TimeCurrent();
      time_begin = StrToTime(TradeBegin);
      if(!EndInTomorrow) {
         time_end = StrToTime(TradeEnd);
      }
      else if(EndInTomorrow) {
         time_end = StrToTime(TradeEnd) + 86400;
         time_end_today = StrToTime(TradeEnd);
      }
      if(!EndInTomorrow && (time_now<time_begin || time_now>time_end)) {
         return(false);
      }
      else if(EndInTomorrow && time_now>time_end_today && time_now<time_begin) {
         return(false);
      }
   }
   return(true);  
  }
  
//+------------------------------------------------------------------+
//| Trade Buy @http://kolier.li @v1.0                                |
//| @import                                                          |
//|   bool ECNBroker                                                 |
//+------------------------------------------------------------------+
void tradeBuy()
  {
   double price_now, price_profit, price_stop, lots;
   double take_profit = pips2Points(TakeProfit);
   double stop_loss = pips2Points(StopLoss);
   int ticket;
   price_now = Ask;
   if(TakeProfit > 0) {
      price_profit = price_now + take_profit*Point;
   }
   else {
      price_profit = 0;
   }
   if(StopLoss > 0) {
      price_stop = price_now - stop_loss*Point;
   }
   else {
      price_stop = 0;
   }
   lots = Lots;
   /*
   if(MoneyManagement) {
      lots = mmLots(StopLoss);
   }
   else {
      lots = Lots;
   }
   */
   
   if(!ECNBroker && !StealthMode) {
      ticket = OrderSend(Symbol(), OP_BUY, lots, price_now, Slippage, price_stop, price_profit, NULL, Magic, 0, Lime);
   }
   else {
      ticket = OrderSend(Symbol(), OP_BUY, lots, price_now, Slippage, 0, 0, NULL, Magic, 0, Lime);
   }
   
   if(ticket < 0) {
      //tradeBuy();
      Print(AdvisorName, "- tradeBuy() error #", GetLastError());
      Print("Price Buy: ", price_now, " TP: ", price_profit, " SL: ", price_stop, " Lots: ", lots);
   }
   else {
      if(ECNBroker) {  
         OrderSelect(ticket, SELECT_BY_TICKET);
         OrderModify(OrderTicket(), OrderOpenPrice(), price_stop, price_profit, 0, CLR_NONE);
      }
   }
  }
  
//+------------------------------------------------------------------+
//| Trade Sell @http://kolier.li @v1.0                               |
//| @import                                                          |
//|   bool ECNBroker                                                 |
//+------------------------------------------------------------------+
void tradeSell()
  {
   double price_now, price_profit, price_stop, lots;
   double take_profit = pips2Points(TakeProfit);
   double stop_loss = pips2Points(StopLoss);
   int ticket;
   price_now = Bid;
   if(TakeProfit > 0) {
      price_profit = price_now - take_profit*Point;
   }
   else {
      price_profit = 0;
   }
   if(StopLoss > 0) {
      price_stop = price_now + stop_loss*Point;
   }
   else {
      price_stop = 0;
   }
   lots = Lots;
   /*
   if(MoneyManagement) {
      lots = mmLots(StopLoss);
   }
   else {
      lots = Lots;
   }
   */

   if(!ECNBroker && !StealthMode) {
      ticket = OrderSend(Symbol(), OP_SELL, lots, price_now, Slippage, price_stop, price_profit, NULL, Magic, 0, Red);
   }
   else {
      ticket = OrderSend(Symbol(), OP_SELL, lots, price_now, Slippage, 0, 0, NULL, Magic, 0, Red);
   }
   
   if(ticket < 0) {
      //tradeBuy();
      Print(AdvisorName, "- tradeSell() error #", GetLastError());
      Print("Price Sell: ", price_now, " TP: ", price_profit, " SL: ", price_stop, " Lots: ", lots);
   }
   else {
      if(ECNBroker) {
         OrderSelect(ticket, SELECT_BY_TICKET);
         OrderModify(OrderTicket(), OrderOpenPrice(), price_stop, price_profit, 0, CLR_NONE);
      }
   }
  }
  
//+------------------------------------------------------------------+
//| Close Buy Trades @http://kolier.li                               |
//+------------------------------------------------------------------+
void closeTradesBuy()
  {
   int trades_total = OrdersTotal();
   for(int i=0; i<trades_total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic) {
         OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), Slippage, White);
      }
   }
  }
  
//+------------------------------------------------------------------+
//| Close Trades Sell @http://kolier.li                              |
//+------------------------------------------------------------------+
void closeTradesSell()
  {
   int trades_total = OrdersTotal();
   for(int i=0; i<trades_total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic) {
         OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), Slippage, White);
      }
   }
  }
  
//+------------------------------------------------------------------+
//| TP and SL stealthly, hide from the trade server                  |
//| Place at the front part of start()                               |
//+------------------------------------------------------------------+
void stealthMode()
  {
   double takeprofit_stealth = pips2Points(TakeProfit)*Point;
   double stoploss_stealth = pips2Points(StopLoss)*Point;
      
   for(int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
         if(OrderType()==OP_BUY && takeprofit_stealth>0
            && (MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice()>=takeprofit_stealth
               || OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_BID)>=stoploss_stealth)) {
            OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
         }
         else if(OrderType()==OP_SELL && stoploss_stealth>0
            && (OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK)>=takeprofit_stealth
               || MarketInfo(OrderSymbol(),MODE_ASK)-OrderOpenPrice()>=stoploss_stealth)) {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
         }
      }
   }
  }
  
//+------------------------------------------------------------------+
//| pips2Points() @http://kolier.li                                  |
//+------------------------------------------------------------------+
double pips2Points(double pips)
  {
   double points;
   if(Close[0]<10) {
      points = pips*MathPow(10,Digits-4);
   }
   else if(Close[0]>10) {
      points = pips*MathPow(10,Digits-2);  
   }
   
   return(points);
  }

//+------------------------------------------------------------------+
//| trailStop Target Points                                          |
//| Scan Trades @http://kolier.li @v1.0                              |
//| @params                                                          |
//|   string order_type TRADEALL|TRADETRADE|TRADEPEND                |
//|   string order_dir TRADEALL|TRADEBUY|TRADESELL                   |
//| @return                                                          |
//|   int orders_number                                              |
//+------------------------------------------------------------------+
int scanTrades(int order_type=TRADEALL, int order_dir=TRADEALL)
  {
   int orders_total = OrdersTotal();
   int orders_number = 0;
   for(int i=0; i<orders_total; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) {
         switch(order_type) {
            case TRADEALL:
               orders_number++;
               break;
            case TRADETRADE:
               if(OrderType()<=OP_SELL) {
                  orders_number = _scanTradesDir(order_dir, orders_number);
               }
               break;
            case TRADEPEND:
               if(OrderType()>OP_SELL) {
                  orders_number = _scanTradesDir(order_dir, orders_number);
               }
               break;
         }// switch
      }
   }
   return(orders_number);   
  }
  
int _scanTradesDir(int order_dir, int orders_number)
  {
      switch(order_dir) {
         case TRADEALL:
            orders_number++;
            break;
         case TRADEBUY:
            if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) {
               orders_number++;
            }
            break;
         case TRADESELL:
            if(OrderType()==OP_SELL || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) {
               orders_number++;
            }
            break;
      }// switch
      return(orders_number);
  }
  
//+------------------------------------------------------------------+
//| Break Even @http://kolier.li                                     |
//+------------------------------------------------------------------+
void breakEven()
  {
   int orders_total = OrdersTotal();
   int i, ticket;
   double break_even_points = pips2Points(BreakEvenPips);
   double break_even_with_profit = pips2Points(BreakEvenWithProfit);
   double stoploss_buy, stoploss_sell;
   string gv_name;
   double break_even_able;
   
   for(i=0; i<orders_total; i++) {
      break_even_able = -1;
      if(!BreakEvenWithProfit) {
         stoploss_buy = OrderOpenPrice();
         stoploss_sell = OrderOpenPrice();
      }
      else {
         stoploss_buy = OrderOpenPrice() + break_even_with_profit*Point;
         stoploss_sell = OrderOpenPrice() - break_even_with_profit*Point;
      }
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && OrderProfit()>0) {
         if(BE_StealthMode) {
            break_even_able = GlobalVariableGet(AdvisorName+"_be_able_"+OrderTicket());
            if(OrderType()==OP_BUY && break_even_able>0 && Bid<=stoploss_buy) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
            }
            else if(OrderType()==OP_SELL && break_even_able>0 && Ask>=stoploss_sell) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
            }
         }
      
         if(OrderType()==OP_BUY && (OrderStopLoss()<stoploss_buy || OrderStopLoss()==0)
            && Bid-OrderOpenPrice()>=break_even_points*Point) {
            if(!BE_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), stoploss_buy, OrderTakeProfit(), 0, Green);
            }
            else {
               GlobalVariableSet(AdvisorName+"_be_able_"+OrderTicket(), 1);
            }
         }
         else if(OrderType()==OP_SELL && (OrderStopLoss()>stoploss_sell || OrderStopLoss()==0)
            && OrderOpenPrice()-Ask>=break_even_points*Point) {
            if(!BE_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), stoploss_sell, OrderTakeProfit(), 0, Magenta);
            }
            else {
               GlobalVariableSet(AdvisorName+"_be_able_"+OrderTicket(), 1);
            }
         }
      }
   }
   
   // Clear the un-used Global Variables
   for(i=0; i<GlobalVariablesTotal(); i++) {
      gv_name = GlobalVariableName(i);
      if(StringSubstr(gv_name, 0, 9+StringLen(AdvisorName))==AdvisorName+"_be_able_") {
         ticket = StrToInteger(StringSubstr(gv_name, 9+StringLen(AdvisorName)));
         OrderSelect(ticket, SELECT_BY_TICKET);
         if(OrderCloseTime()>0) {
            GlobalVariableDel(gv_name);
         }
      }
   }
  }

//+------------------------------------------------------------------+
//| Trail Stop @http://kolier.li                                     |
//+------------------------------------------------------------------+
void trailStop()
  {
   int ticket;
   string gv_name;
   double trail_stop_points = pips2Points(TrailStopPips)*Point;
   double ts_chunk = pips2Points(TS_Chunk)*Point;
   double stoploss_order;
   
   for(int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
         if(!TS_StealthMode) {
            stoploss_order = OrderStopLoss();
         }
         else {
            stoploss_order = GlobalVariableGet("ts_stoploss_"+OrderTicket());
            
            if(stoploss_order>0) {
               if(OrderType()==OP_BUY && Bid<=stoploss_order) {
                  OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, White);
                  GlobalVariableDel(AdvisorName+"_ts_stoploss_"+OrderTicket());
                  continue;
               }
               else if(OrderType()==OP_SELL && Ask>=stoploss_order) {
                  OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, White);
                  GlobalVariableDel(AdvisorName+"_ts_stoploss_"+OrderTicket());
                  continue;
               }
            }
         }

         if(OrderType()==OP_BUY
            && ((Bid-trail_stop_points>stoploss_order && stoploss_order>0) || stoploss_order==0)
            && (!TrailAfterEven || (TrailAfterEven && Bid-trail_stop_points>=OrderOpenPrice()))
            && (!TS_MovingInChunk || (TS_MovingInChunk && ((Bid-stoploss_order>trail_stop_points+ts_chunk && stoploss_order>0) || stoploss_order==0)))) {
            if(!TS_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), Bid-trail_stop_points, OrderTakeProfit(), 0, Blue);
            }
            else {
               GlobalVariableSet(AdvisorName+"_ts_stoploss_"+OrderTicket(), Bid-trail_stop_points);
            }
         }
         else if(OrderType()==OP_SELL
            && ((Ask+trail_stop_points<stoploss_order && stoploss_order>0) || stoploss_order==0)
            && (!TrailAfterEven || (TrailAfterEven && Ask+trail_stop_points<=OrderOpenPrice()))
            && (!TS_MovingInChunk || (TS_MovingInChunk && ((stoploss_order-Ask>trail_stop_points+ts_chunk && stoploss_order>0) || stoploss_order==0)))) {
            if(!TS_StealthMode) {
               OrderModify(OrderTicket(), OrderOpenPrice(), Ask+trail_stop_points, OrderTakeProfit(), 0, Orange);
            }
            else {
               GlobalVariableSet(AdvisorName+"_ts_stoploss_"+OrderTicket(), Ask+trail_stop_points);
            }
         }
      }
   }
   
   // Clear the un-used Global Variables
   for(i=0; i<GlobalVariablesTotal(); i++) {
      gv_name = GlobalVariableName(i);
      if(StringSubstr(gv_name, 0, 13+StringLen(AdvisorName))==AdvisorName+"_ts_stoploss_") {
         ticket = StrToInteger(StringSubstr(gv_name, 13+StringLen(AdvisorName)));
         OrderSelect(ticket, SELECT_BY_TICKET);
         if(OrderCloseTime()>0) {
            GlobalVariableDel(gv_name);
         }
      }
   }
  }
  
//+------------------------------------------------------------------+
//| Whether traded in that bar, default to current bar               |
//| with specific op type                                            |
//| @http://kolier.li                                                |
//+------------------------------------------------------------------+
bool tradedInBarOP(int op_type, int shift=0)
  {
   datetime time_begin = Time[shift];
   datetime time_end = time_begin + Period()*60;
   int i;
   for(i=0; i<OrdersTotal(); i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol()
        && OrderOpenTime()>=time_begin && OrderOpenTime()<=time_end
        && OrderType()==op_type) {
         return(true);
      }
   }
   for(i=0; i<OrdersHistoryTotal(); i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol()
        && OrderOpenTime()>=time_begin && OrderOpenTime()<=time_end
        && OrderType()==op_type) {
         return(true);
      }
   }
   
   return(false);
  }