//+------------------------------------------------------------------+
//|                                              SpreadIndikator.mq4 |
//|                               Copyright  2010 MeinMetatrader.de |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010 MeinMetatrader.de"
#property link      ""

#property indicator_chart_window
//#property indicator_buffers 0

extern color LabelColor = Red;

#define OBJ_NAME "SpreadIndikatorObj"

int init()
{
   ShowSpread();
}

int start()
{
   ShowSpread();
}

int deinit()
{
   ObjectDelete(OBJ_NAME);
}

void ShowSpread()
{
   // ECN Broker
   int ECN = PairDigits(Symbol());
   
   static double spread;
   
   spread = MarketInfo(Symbol(), MODE_SPREAD)/ECN;
   
   DrawSpreadOnChart(spread);
}

void DrawSpreadOnChart(double spread)
{
   string s = "Spread: "+DoubleToStr(spread, 1)+" points";
   
   if(ObjectFind(OBJ_NAME) < 0)
   {
      ObjectCreate(OBJ_NAME, OBJ_LABEL, 0, 0, 0);
      ObjectSet(OBJ_NAME, OBJPROP_CORNER, 1);
      ObjectSet(OBJ_NAME, OBJPROP_YDISTANCE, 12);
      ObjectSet(OBJ_NAME, OBJPROP_XDISTANCE, 3);
      if (spread < 2) LabelColor = Green;
      else LabelColor = Red;
      ObjectSetText(OBJ_NAME, s, 10, "FixedSys", LabelColor);
   }
   
   ObjectSetText(OBJ_NAME, s);
   
   WindowRedraw();
}

// ===== Routine per calcolare cifre decimali delle valute =====
int PairDigits(string Pair)
{
  int Temp = 1;
  
  if ( MarketInfo(Pair,MODE_DIGITS) == 3 || MarketInfo(Pair,MODE_DIGITS) == 5 ) { Temp = 10; } 
  
  return(Temp);
}