/*
   .
iCustom(string symbol, int timeframe, "_StochNR", int %Kperiod, int %Dperiod, 
int slowing, int method, int price_field, double sens, int mode, int shift);
iCustom(NULL,0,"_StochNR",Kperiod,Dperiod,Slowing,Dmethod,PriceFild,Sens, 0,i);
*/

#property indicator_separate_window //  .  
#property indicator_buffers 3
#property indicator_color1 Green // 
#property indicator_style1 0
#property indicator_color2 Red // 
#property indicator_style2 2
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 80
#property indicator_level2 20

//  
extern int Kperiod=5; // %K  
extern int Dperiod=3; // %D  
extern int Slowing=3; // 
extern int Dmethod=0; //  MA : 0-SMA, 1-EMA
extern int PriceFild=0; //  : 0-High/Low; 1-Close/Close
extern int Volatility=66; // >0  ATR, <0  StDev
extern double xVolatility=4; //  
extern double Sens=0; //   .
 int History=0; //  : 0 -  

// .
double   Main[]; // 
double   Signal[]; // 
double VLT[]; //  (  -  )
//  
bool first=1; //   
double sens=0; //   
double kd; // . EMA  
bool StdATR; //  StDev/ATR

int init()
  {
   first=1;
   sens=Sens*Point;
   
   if(Dmethod==1) kd=2.0/(1+Dperiod); // . EMA  
   if(Volatility<0) {Volatility=-Volatility; StdATR=1;} else StdATR=0;

   //     
   SetIndexBuffer(0,Main);
   SetIndexStyle(0,DRAW_LINE);
   string _str="("+Kperiod+","+Slowing+")";
   SetIndexLabel(0,"Main"+_str);
   //  
   SetIndexBuffer(1,Signal);
   SetIndexStyle(1,DRAW_LINE);
   _str="("+Dperiod+")";
   SetIndexLabel(1,"Signal"+_str);
   //  
   SetIndexBuffer(2,VLT);
   SetIndexLabel(2,"Sensitivity");

   //  
   if(Sens>0) string ShName=DoubleToStr(Sens,1)+" ";
   if(Volatility>0 && xVolatility>0) {
      if(StdATR)  ShName=ShName+"StDev";
      else        ShName=ShName+"ATR";
      ShName=ShName+"("+Volatility+")x"+DoubleToStr(xVolatility,1)+" ";
     }
   ShName=ShName+"Stoch ";
   if(PriceFild==0) ShName=ShName+"H/L";
   else ShName=ShName+"C/C";
   ShName=ShName+" ("+Kperiod+","+Dperiod+","+Slowing+")";
   IndicatorShortName(ShName);   
   
   return(0);
  }

int reinit() // -  
  {
   ArrayInitialize(Main,0.0);
   ArrayInitialize(Signal,0.0);
   ArrayInitialize(VLT,0.0);
   return(0);
  }

int start()
  {
   int ic=IndicatorCounted();
   if(!first && Bars-ic-1>1) ic=reinit(); first=0;
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      // 
      double vlt=0,sn;
      if(xVolatility>0 && Volatility>0) {
         if(StdATR)  vlt=iStdDev(NULL,0,Volatility,0,0,0, i); //  ..
         else        vlt=iATR(NULL,0,Volatility, i); //  .
         vlt*=xVolatility;
        }
      sn=MathMax(vlt,sens);
      VLT[i]=sn; //    ( )
      // 
      Main[i]=Stoch(Kperiod, Slowing, PriceFild, sn, i);
      // 
      switch(Dmethod) {
         case 1: // EMA
            Signal[i]=kd*Main[i]+(1-kd)*Signal[i+1]; break;
         case 0: // SMA
            int sh=i+Dperiod;
            double ma=Signal[i+1]*Dperiod-Main[sh];
            Signal[i]=(ma+Main[i])/Dperiod;
        }
     }
   return(0);
  }
  
//   
double Stoch(int Kperiod, int Slowing, int PriceFild, double sens, int i) {  
   if(i+Kperiod+Slowing>Bars) return(-1); //   - 
   //     /
   double max,min,c;
   for(int j=i; j<i+Slowing; j++) {
      if(PriceFild==1) { //  Close
         max+=Close[ArrayMaximum(Close,Kperiod,j)];
         min+=Close[ArrayMinimum(Close,Kperiod,j)];
        }
      else { //  High/Low
         max+=High[ArrayMaximum(High,Kperiod,j)];
         min+=Low[ArrayMinimum(Low,Kperiod,j)];
        }
      c+=Close[j];
     }
   // 
   sens*=Slowing; //       
   double delta=max-min; // 
   double diff=sens-delta; //    .  
   if(diff>0) { //   >0 (  ), 
      delta=sens; //  = ,
      min-=diff/2; //   
     }
   //  
   if(delta==0) return(-1);
   else return(100*(c-min)/delta);
  }


